#include "server.h"

void createmon(struct wl_listener *listener, void *data) {

}

void server_init(struct server *server) {
	server->wl_display = wl_display_create();
	assert(server->wl_display);

	server->wl_event_loop = wl_display_get_event_loop(server->wl_display);
	assert(server->wl_event_loop);

	server->backend = wlr_backend_autocreate(server->wl_display);
	assert(server->backend);

	server->renderer = wlr_renderer_autocreate(server->backend);
	assert(server->renderer);

	wlr_renderer_init_wl_display(server->renderer, server->wl_display);

	server->alloc = wlr_allocator_autocreate(server->backend, server->renderer);
	assert(server->alloc);

	server->compositor = wlr_compositor_create(server->wl_display, server->renderer);
	wlr_export_dmabuf_manager_v1_create(server->wl_display);
	wlr_screencopy_manager_v1_create(server->wl_display);
	wlr_data_control_manager_v1_create(server->wl_display);
	wlr_data_device_manager_create(server->wl_display);
	wlr_gamma_control_manager_v1_create(server->wl_display);
	wlr_primary_selection_v1_device_manager_create(server->wl_display);
	wlr_viewporter_create(server->wl_display);
	wlr_single_pixel_buffer_manager_v1_create(server->wl_display);
  	wlr_subcompositor_create(server->wl_display);

	wl_list_init(&server->outputs);
	wl_signal_add(&server->backend->events.new_output, &new_output);

	const char *socket = wl_display_add_socket_auto(server->wl_display);
	assert(socket);

	printf("Running compositor on wayland display '%s'\n", socket);
	setenv("WAYLAND_DISPLAY", socket, 1);

	if (!wlr_backend_start(server->backend)) {
		wl_display_destroy(server->wl_display);
		die("wlr_backend_start", 1);
	}

}
